
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>用C++如何实现开放API接口服务器 / 憋错料</title>

    <meta name="description" content="用C++如何实现开放API接口服务器 比如新浪微博的API服务器.接口是使用HTTP请求.服务器端如何实现一个HTTP SERVER呢?使用libcurl可以吗? c++的话,一般用libevent或则libev这种库来实现吧.当然如果对epoll比较熟悉的话 直接用也没问题. 基于epoll的http服务器实现:http://www.cnblogs.com/clowwindy/archive/2011/09/23/a_http_server_faster_than_nginx.html 为啥要自已写一个HTTP Server呢?直">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">用C++如何实现开放API接口服务器</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>比如新浪微博的API服务器。<br />接口是使用HTTP请求。<br />服务器端如何实现一个HTTP SERVER呢？<br />使用libcurl可以吗？</p>
<p>c++的话，一般用libevent或则libev这种库来实现吧。当然如果对epoll比较熟悉的话 直接用也没问题。</p>
<p>基于epoll的http服务器实现：http://www.cnblogs.com/clowwindy/archive/2011/09/23/a_http_server_faster_than_nginx.html</p>
<p>为啥要自已写一个HTTP Server呢？直接用Nginx或Apache+PHP/Java/Ruby等就行嘛~</p>
<p>自已写应该没有用成熟的现成系统来得稳定可靠~</p>
<p>搜素了下，libcurl只能作为<a href="http://www.libcurl.org/" rel="external nofollow noreferrer">客户端使用</a></p>
<p>http server 库还想有：<br />libmicrohttpd<br />shttpd<br />easyhttpd<br />cpphttpd</p>
<p><em></p>
<p></em></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 19:44:13 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>用C++如何实现开放API接口服务器的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qE6GN3.html" rel="bookmark">Android测试工具ThreadingTest开放API接口说明</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ThreadingTest(简称TT)第一期是一款Android白盒测试工具,使用离线检测的方式,在保护用户源代码的基础上,运用插装.第五代覆盖率等技术,为开发工程师与测试工程师提供一套高效可量化.可视化的交流工具.对比其它测试工具,TT在自动化测试时,会对应测试用例自动生成测试用例和代码之间的关系以及函数覆盖率,并且以TT自带的双向追溯图进行展示,在整个自动化测试进行过程中,TT还会以示波器界面可视化的监控整个自动化测试中每时每刻获取的测试数据. 基于其它测试工具测试时,TT还开放了API接口			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02wjwn3.html" rel="bookmark">开放API接口 笑话、天气、新闻</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				笑话接口示例: http://api.1-blog.com/biz/bizserver/xiaohua/list.do?maxXhid=1000000&amp;size=1&amp;minXhid=6 开放API接口 笑话.天气.新闻 博客分类: 其它 API新闻笑话天气开放API 闲来无事,弄了几个API接口,分享给同样需(闲的)要(没事儿)的人吧 API接口都是HTTP形式的,数据都是json格式,支持ajax调用(已开放所有域名访问) PS:演示网站http://1-blog.com 使用的人麻烦加			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QXkYl3.html" rel="bookmark">Web服务器和API接口服务器心跳检查</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				https://blog.csdn.net/lgcjava/article/details/77131695 作为后台开发兼运维人员,web服务器.api接口服务器.开发测试的各种工具(JIRA/bitbucket)等等越来越多.能否有个工具能实时监控各个服务器的运行状态.如果出现异常,及时邮件和微信通知自己呢?    最后在发现heartbeart这款开源软件,正是我要找的.配置实例.运行后自动监控心跳.异常发生邮件通知.    在运行时发现一些配置问题和功能缺陷,比如实例查询不支持中文.不支			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xz8wN4.html" rel="bookmark">开放API接口及其安全性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开放出来给别人调用的API接口是就是开放API接口. 弱点: 数据窃取 用户的密码等信息被不轨之人窃取,登录账号发布敏感信息,盗刷等. 数据篡改 提交的数据被抓包后进行篡改再提交. 数据泄露 爬虫将业务数据甚至核心数据抓取,直接或者间接造成损失. RSA/DES加密 MD5混淆 TOKEN令牌 有令牌才能通过,没有令牌则不能通过 加密分为对称加密和非对称加密 对称加密有:DES,AES 加密和解密是使用同一套秘钥 非对称加密有:RSA 公钥和私钥 公钥加密,私钥解密 RSA可以用来加密和签名 H			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eyewJ0.html" rel="bookmark">开放api接口签名验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				不要急,源代码分享在最底部,先问大家一个问题,你在写开放的API接口时是如何保证数据的安全性的?先来看看有哪些安全性问题在开放的api接口中,我们通过http Post或者Get方式请求服务器的时候,会面临着许多的安全性问题,例如: 请求来源(身份)是否合法? 请求参数被篡改? 请求的唯一性(不可复制) 为了保证数据在通信时的安全性,我们可以采用参数签名的方式来进行相关验证. 案列分析 我们通过给某 [移动端(app)] 写 [后台接口(api)] 的案例进行分析: 客户端: 以下简称app 后			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXvw1k3.html" rel="bookmark">【转】开放api接口签名验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				不要急,源代码分享在最底部,先问大家一个问题,你在写开放的API接口时是如何保证数据的安全性的?先来看看有哪些安全性问题在开放的api接口中,我们通过http Post或者Get方式请求服务器的时候,会面临着许多的安全性问题,例如: 1. 请求来源(身份)是否合法? 2. 请求参数被篡改? 3. 请求的唯一性(不可复制) 为了保证数据在通信时的安全性,我们可以采用参数签名的方式来进行相关验证. 案列分析 我们通过给某 [移动端(app)] 写 [后台接口(api)] 的案例进行分析: 客户端:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bzBmp0.html" rel="bookmark">几个开放API接口 笑话、天气、新闻</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				闲来无事,弄了几个API接口,分享给同样需(闲的)要(没事儿)的人吧API接口都是HTTP形式的,数据都是json格式,支持ajax调用(已开放所有域名访问) 笑话API 说明:调用后返回笑话列表,可以在参数中设置已经获取的最大笑话ID和最小笑话ID,返回结果会返回新的笑话(目前大概1w条左右,持续增加中)使用方式请求地址:http://114.215.158.105:8080/bizserver/xiaohua/list.do示例 http://114.215.158.105:8080/htm			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dRaD64.html" rel="bookmark">远程开户系统开放API接口</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如今随着智能识别技术的成熟和商用,金融领域也开始逐渐试水&quot;远程开户&quot;.从OCR身份证识别到人脸识别,到如今市场上即将出现完整的远程开户系统,除了需要成熟的技术做支撑外,还需要对市场有着前瞻性的眼光. 这套远程开户系统包含了OCR身份证识别技术.银行卡识别技术.人脸识别等智能识别技术.即利用身份证识别快速采集验证用户身份,并通过联网核查进行验证身份信息,用来核实用户的真实身份;然后利用银行卡识别一键绑定银行卡,再辅以视频人脸识别进行身份进一步验证,确保开户者与证件持有者为同一人,做到人证			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49gw5p0.html" rel="bookmark">springcloud提供开放api接口签名验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.MD5参数签名的方式 我们对api查询产品接口进行优化: 1.给app分配对应的key.secret 2.Sign签名,调用API 时需要对请求参数进行签名验证,签名方式如下: a. 按照请求参数名称将所有请求参数按照字母先后顺序排序得到:keyvaluekeyvalue...keyvalue  字符串如:将arong=1,mrong=2,crong=3 排序为:arong=1, crong=3,mrong=2  然后将参数名和参数值进行拼接得到参数字符串:arong1crong3mrong			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/XMmPwp4.html" rel="bookmark" class="title">SQLiteDatabase 基本操作</a>
					<div>
						一.SQLiteOpenHelper类 android 提供类SQLiteOpenHelper帮助用户简化对SQLite数据库的操作.该类是一个抽象类,必须用户自己实现并重写oncreate()和on ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35Vpen4.html" rel="bookmark" class="title">草泥马</a>
					<div>
						你总是天真的认为项目简单, 还说,随便要谁来都可以负责得起.  你不看看你自己,其实也是改不动的, 引起一大摞的bug. 极难维护我就不说了. 自己代码写得乱七八糟, 让别人来背黑锅. 然后又嫌人家做 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzaNKd4.html" rel="bookmark" class="title">&lbrack;2015编程之美&rsqb; 第一场A</a>
					<div>
						#1156 : 彩色的树 时间限制:2000ms 单点时限:1000ms 内存限制:256MB 描述 给定一棵n个节点的树,节点编号为1, 2, …, n.树中有n - 1条边,任意两个节点间恰好有一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02bavz0.html" rel="bookmark" class="title">使用BeautifulSoup抓取</a>
					<div>
						年前有个坑爹的需求来了,要把某点评网商户数据都给获取下来存储于数据库,好啦其实这个东西是蛮简单的: 首先到点评网把城市数据给拷贝下来,当然你也可以写个脚本把数据抓取下来,不够我没这么干:好了下面是用于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MX7a2z4.html" rel="bookmark" class="title">再Windows下 &period;Pages格式怎么保存为word或者PDF格式</a>
					<div>
						今天上班正好有同事在问这个问题,所以研究了一下. 再没有MAC系统或者没有装MAC的Pages软件的情况下 最后得到的答案是只要能上网开网页: 2种方法: 苹果的iCould(https://beta ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz51Yq4.html" rel="bookmark" class="title">BestCoder Round &num;36 &lpar;hdu5198&rpar;Strange Class（水题）</a>
					<div>
						转载请注明出处: http://www.cnblogs.com/fraud/          ——by fraud Strange Class Time Limit: 2000/1000 MS (J ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mg5Qeg3.html" rel="bookmark" class="title">剿卜唾粕巡聊伎窝托倌卫仑既韧欧</a>
					<div>
						weheartit.com/przvffhnxbrnbtjr/collections/61809558-201412-29/ weheartit.com/dnhjbdzptptllbbl/collec ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02DzdD4.html" rel="bookmark" class="title">STM32  高速定时器配置为PWM使用细节</a>
					<div>
						//初始化TIM8 Channel1 PWM?模式 TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM2; // TIM_OCInitStructure.T ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4p5kJwM.html" rel="bookmark" class="title">半年五起收购 思科密集整合欲自我救赎（创新都来自小而美的公司，思科不想扼杀这股创新力）</a>
					<div>
						半年五起收购 思科密集整合欲自我救赎 吴微 有“收购大师”之称的思科近日又宣布了一项新交易. 这次收购的是云安全公司CloudLock,交易总价格为2.93亿美元.这是思科公司今年发起的第五宗收购交易 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d95X63.html" rel="bookmark" class="title">C&plus;&plus;多重继承的实现</a>
					<div>
						// //  main.cpp //  test // //  Created by Jacedy on 14-11-6. //  Copyright (c) 2014年 Jacedy. All ri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bOzrY3.html" rel="bookmark" class="title">Java 内联函数</a>
					<div>
						在说内联函数之前,先说说函数的调用过程. 调用某个函数实际上将程序执行顺序转移到该函数所存放在内存中某个地址,将函数的程序内容执行完后,再返回到  转去执行该函数前的地方.这种转移操作要求在转去前要保 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ko7KE0.html" rel="bookmark" class="title">MediaRecorder实现微信、QQ、人人、易信等语音录制功能工具&colon;MediaUtilAPI</a>
					<div>
						本文介绍使用MediaRecorder进行录制音频.录制视频学习,熟悉MediaRecorder执行流程,通过简单的Demo结合解释运行效果,最后封装MediaRecorder的API工具,实现常见比 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyQebeM.html" rel="bookmark" class="title">cocos2d-x 扩充引擎基类功能 引起的头文件重复包含问题的分析</a>
					<div>
						c++ 头文件包含 原因的分析:   c++  头文件的循环引用是指: .h 里面的里面的头文件的相互包含的,引起的重复引用的问题.cpp 里面包含头文件是不存在重复引用的问题(因为CPP没有#ifn ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4J9yOB3.html" rel="bookmark" class="title">tcp&lowbar;wraper</a>
					<div>
						tcp_wraper: libwrap.so 必须在编译的时候链接到libwrap.so这个库之后才能实现调用tcp_wraper实现访问控制 可以通过ldd来查看 [[email protected ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vBzlZ3.html" rel="bookmark" class="title">一周云计算动态2016-08-16</a>
					<div>
						阿里2017财年第一季度财报:云计算业务营收劲增156% 云计算业务保持强劲势头,营收达12.43亿元,同比增长156% 阿里云的云计算付费用户数量同比去年增长超一倍,达到57.7万. 季度内,阿里云 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVvmeyM.html" rel="bookmark" class="title">【SC】SCOM-Agent安装&mdash;基于Uinx&bsol;Linux</a>
					<div>
						--------Uinx\Linux---SCOM-Agent安装------ 对于SCOM代理的安装,网上已经有相当多的图文教程了,为什么还有要写呢?其实网上的其他教程有一些地方是存在瑕疵的,新手如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLrJme3.html" rel="bookmark" class="title">hbase shell基础和常用命令详解&lpar;转&rpar;</a>
					<div>
						HBase shell的基本用法 hbase提供了一个shell的终端给用户交互.使用命令hbase shell进入命令界面.通过执行 help可以看到命令的帮助信息. 以网上的一个学生成绩表的例子来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dE5r93.html" rel="bookmark" class="title">8月30日 第六次课&lpar;01&rpar; Linux文本编辑工具vim的使用作业</a>
					<div>
						1.如何将自动缩进的字符从默认的八个改为四个 :set tabstop=4 2.复制/etc/grub2.cfg配置文件至/tmp目录,用查找替换命令删除文件中的行首空白字符 centos6则复制/e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41eeDk4.html" rel="bookmark" class="title">表述你的产品</a>
					<div>
						这段时间给一家公司设计网站,其中一个环节就是展示他们公司的产品.一般来说,如果想展示一个产品或商品,参考一下京东商城什么的就可以,产品展示的内容还是比较丰富和全面的.本人不才,试着概括一二: 产品的图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgQJEL3.html" rel="bookmark" class="title">Exercise1-10</a>
					<div>
						%E7%BC%96%E5%A5%BD%E7%A8%8B%E5%BA%8F%E9%80%81%E8%BF%9B%E4%BA%86plc%E5%AE%83%E5%B0%B1%E6%98%AF%E4%B8% ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
